using System;

namespace Poklon
{
    class Program
    {
        static void Main()
        {
            int n = int.Parse(Console.ReadLine());
            int[] a = new int[n];
            string[] s = Console.ReadLine().Split();

            for (int i = 0; i < n; i++)
                a[i] = int.Parse(s[i]);

            int q = int.Parse(Console.ReadLine());
            while (q > 0)
            {
                bool da = true;
                s = Console.ReadLine().Split();
                int l = int.Parse(s[0]);
                int r = int.Parse(s[1]);

                int br = 0;
                int index = 1;

                if ((r / 2) % 2 == 0)
                {
                    for (int i = l - 1; da && i <= r / 2 - 1; i++)
                    {
                        if (a[i] > a[i + 1] || a[r - index] < a[r - index - 1])
                        {
                            br++;
                            if (a[i + 1] != a[r - index] && a[i] > a[i + 1] && a[r - index] < a[r - index - 1] || br >= 2) //1.
                                da = false;
                        }
                        index++;
                    }
                }
                else
                {
                    for (int i = l - 1; da && i <= r / 2; i++)
                    {
                        if (a[i] > a[i + 1] || a[r - index] < a[r - index - 1])
                        {
                            br++;
                            if (a[i + 1] != a[r - index - 1] && a[i] > a[i + 1] && a[r - index] < a[r - index - 1] || br >= 2) //1.
                                da = false;
                        }
                        index++;
                    }
                }

                Console.WriteLine(da ? "DA" : "NE");
                q--;
            }
        }
    }
}